package com.eco.plugin.xx.bjgjlog.config;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.intelli.record.Focus;
import com.fr.intelli.record.Original;
import com.fr.record.analyzer.EnableMetrics;

@Visualization(category = "日志推送配置")
@EnableMetrics
public class PluginLogSimpleConfig extends DefaultConfiguration {

    private static volatile PluginLogSimpleConfig config = null;

    @Focus(id="com.eco.plugin.xx.bjgjlog.config", text = "日志推送配置", source = Original.PLUGIN)
    public static PluginLogSimpleConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(PluginLogSimpleConfig.class);
        }
        return config;
    }

    @Identifier(value = "appid", name = "appid", description = "appid", status = Status.SHOW)
    private Conf<String> appid = Holders.simple("");

    @Identifier(value = "appSecret", name = "appSecret", description = "appSecret", status = Status.SHOW)
    private Conf<String> appSecret = Holders.simple("");

    @Identifier(value = "dataset", name = "数据集名称", description = "数据集名称", status = Status.SHOW)
    private Conf<String> dataset = Holders.simple("");

    @Identifier(value = "rjjk", name = "批量推送日志接口", description = "批量推送日志接口", status = Status.SHOW)
    private Conf<String> rjjk = Holders.simple("");

    public String getAppSecret() {
        return appSecret.get();
    }

    public void setAppSecret(String url) {
        this.appSecret.set(url);
    }

    public String getAppid() {
        return appid.get();
    }

    public void setAppid(String url) {
        this.appid.set(url);
    }

    public String getDataset() {
        return dataset.get();
    }

    public void setClientId(String url) {
        this.dataset.set(url);
    }

    public String getRjjk() {
        return rjjk.get();
    }

    public void setRjjk(String url) {
        this.rjjk.set(url);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        PluginLogSimpleConfig cloned = (PluginLogSimpleConfig) super.clone();
//        cloned.text = (Conf<String>) text.clone();
//        cloned.count = (Conf<Integer>) count.clone();
//        cloned.price = (Conf<Double>) price.clone();
//        cloned.time = (Conf<Long>) time.clone();
//        cloned.student = (Conf<Boolean>) student.clone();
        return cloned;
    }

}
