package com.eco.plugin.xx.bjgjlog.db.controller;

import com.eco.plugin.xx.bjgjlog.db.bean.TimeRecordEntity;
import com.eco.plugin.xx.bjgjlog.db.dao.RecordDao;
import com.eco.plugin.xx.bjgjlog.utils.FRUtils;
import com.fr.db.fun.impl.AbstractDBAccessProvider;
import com.fr.plugin.transform.FunctionRecorder;
import com.fr.record.analyzer.EnableMetrics;
import com.fr.stable.db.accessor.DBAccessor;
import com.fr.stable.db.action.DBAction;
import com.fr.stable.db.dao.DAOContext;
import com.fr.stable.db.dao.DAOProvider;
import com.fr.third.jgroups.util.UUID;

/**
 * @author xx
 * @version 10.0
 * Created by xx on 2021-07-29
 **/
@EnableMetrics
@FunctionRecorder
public class DBController extends AbstractDBAccessProvider {

    private static DBAccessor accessor;

    public static DBAccessor getAccessor() {
        return accessor;
    }

    @Override
    public DAOProvider[] registerDAO() {
        return new DAOProvider[]{
                RecordDao.DAO
        };
    }

    @Override
    public void onDBAvailable(DBAccessor accessor) {
        DBController.accessor = accessor;
    }


    /**
     * 添加记录
     * @param recordEntity
     * @return
     */
    public static boolean addRecord(TimeRecordEntity recordEntity){

        try{
            accessor.runDMLAction(new DBAction<Boolean>() {
                @Override
                public Boolean run(DAOContext context) throws Exception {
                    recordEntity.setId(UUID.randomUUID().toString());
                    context.getDAO(RecordDao.class).add(recordEntity);
                    return true;
                }
            });
        }catch(Throwable e){
            FRUtils.FRLogError("addRecord exception ->"+e.getMessage() );
            return false;
        }


        return true;
    }


}
