package com.eco.plugin.xx.bjgjlog.db.dao;

import com.eco.plugin.xx.bjgjlog.db.bean.TimeRecordEntity;
import com.fr.stable.db.dao.BaseDAO;
import com.fr.stable.db.dao.DAOProvider;
import com.fr.stable.db.session.DAOSession;
import com.fr.stable.query.QueryFactory;
import com.fr.stable.query.condition.QueryCondition;
import com.fr.stable.query.restriction.RestrictionFactory;

import java.util.List;

/**
 * @author xx
 * @version 10.0
 * Created by xx on 2021-12-03
 **/
public class RecordDao extends BaseDAO<TimeRecordEntity> {

    public RecordDao(DAOSession session) {
        super(session);
    }

    @Override
    protected Class<TimeRecordEntity> getEntityClass() {
        return TimeRecordEntity.class;
    }

    public final static DAOProvider DAO = new DAOProvider() {
        @Override
        public Class getEntityClass() {
            return TimeRecordEntity.class;
        }

        @Override
        public Class<? extends BaseDAO> getDAOClass() {
            return RecordDao.class;
        }
    };

    public void add(TimeRecordEntity entity) throws Exception {
        getSession().persist(entity);
    }

    public void remove(String id) throws Exception {
        getSession().remove(QueryFactory.create()
                        .addRestriction(RestrictionFactory.eq("id", id)),
                this.getEntityClass());
    }

    public void update(TimeRecordEntity entity) throws Exception {
        getSession().merge(entity);
    }


    public TimeRecordEntity getByUsername(String username) throws Exception {
        QueryCondition condition = QueryFactory.create()
                .addRestriction(RestrictionFactory.eq("username", username));

        return findOne(condition);
    }


    public List<TimeRecordEntity> like(String pid, String type)throws Exception{
        QueryCondition condition = QueryFactory.create()
                .addRestriction(RestrictionFactory.like("", pid)).addRestriction(RestrictionFactory.like(TimeRecordEntity.COLUMN_ID,type));
        return find(condition);
    }
}
